; Project built with Solar Assembler Version 0.36.12

section "code" class_code alias ".text"
section "data" class_data alias ".data"
section "data?" class_bss alias ".data?"

include		Dlgbox.inc

.data
msg		db 'Dialog box demo',0
title1		db 'About',0
Resource	db 'MYDIALOG',0

.data?
hBrush		dd ?

IDM_ABOUT	equ 11
IDM_EXIT	equ 12
IDC_ABOUT	equ 110
IDC_EXIT	equ 120
IDC_EDIT	equ 3000

.entry _start

.code

_start:

	invoke     GetModuleHandle,NULL
	invoke     DialogBoxParam,eax,Resource,NULL,DlgProc,NULL
	invoke     ExitProcess,eax

PROC DlgProc
ARG  hWnd,uMsg,wParam,lParam
	
	.IF [uMsg] == WM_INITDIALOG

		invoke    LoadIcon,NULL,IDI_APPLICATION	
		invoke    SendMessage,[hWnd],WM_SETICON,ICON_SMALL,eax
        
	.ELSEIF [uMsg] == WM_CTLCOLORDLG

		invoke    CreateSolidBrush,Blue
		mov       [hBrush],eax
		ret

	.ELSEIF [uMsg] == WM_CLOSE
		
		invoke    DeleteObject,[hBrush]
		invoke    EndDialog,[hWnd],NULL

	.ELSEIF	[uMsg] == WM_COMMAND
		
			mov	eax,[wParam]

			.IF	[lParam] == 0

				.IF	ax == IDM_ABOUT

					invoke MessageBox,NULL,msg,title1,MB_OK
                        
				.ELSEIF	ax == IDM_EXIT

					invoke SendMessage,[hWnd],WM_CLOSE,0,0

				.ENDIF

			.ELSE

				mov	edx,[wParam]
				shr	edx,16

					.IF dx == BN_CLICKED
                                
						.IF ax == IDC_ABOUT

							invoke SendMessage,[hWnd],WM_COMMAND,IDM_ABOUT,0
                        	
						.ELSEIF ax == IDC_EXIT

							invoke  SendMessage,[hWnd],WM_CLOSE,0,0

						.ENDIF

					.ENDIF

			.ENDIF
	.ELSE

		mov	eax,FALSE
		ret

	.ENDIF
	mov	eax,TRUE
	ret
ENDP
